/* $Id: set.ch,v 1.4 1999/07/09 01:21:51 dholm Exp $

   Harbour Project source code

   This module contains the defines needed for Harbour programs to use
   the SET function

   Copyright 1999 David G. Holm <dholm@jsd-llc.com>
   www - http://www.harbour-project.org

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version, with one exception:

   The exception is that if you link the Harbour Runtime Library (HRL)
   and/or the Harbour Virtual Machine (HVM) with other files to produce
   an executable, this does not by itself cause the resulting executable
   to be covered by the GNU General Public License. Your use of that
   executable is in no way restricted on account of linking the HRL
   and/or HVM code into it.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA (or visit
   their web site at http://www.gnu.org/).

   V 1.4    David G. Holm               Added my email address.
   V 1.3    David G. Holm               Added copyright and license header,
                                        along with a complete version history.
   V 1.2    Victor Szel                 Change not documented.
   V 1.1    Manuel Ruiz                 Committed to CVS.
   V 1.0    David G. Holm               Initial version.
*/

#define _SET_ALTERNATE    1
#define _SET_ALTFILE      2
#define _SET_BELL         3
#define _SET_CANCEL       4
#define _SET_COLOR        5
#define _SET_CONFIRM      6
#define _SET_CONSOLE      7
#define _SET_CURSOR       8
#define _SET_DATEFORMAT   9
#define _SET_DEBUG        10
#define _SET_DECIMALS     11
#define _SET_DEFAULT      12
#define _SET_DELETED      13
#define _SET_DELIMCHARS   14
#define _SET_DELIMITERS   15
#define _SET_DEVICE       16
#define _SET_EPOCH        17
#define _SET_ESCAPE       18
#define _SET_EVENTMASK    19
#define _SET_EXACT        20
#define _SET_EXCLUSIVE    21
#define _SET_EXIT         22
#define _SET_EXTRA        23
#define _SET_EXTRAFILE    24
#define _SET_FIXED        25
#define _SET_INSERT       26
#define _SET_INTENSITY    27
#define _SET_MARGIN       28
#define _SET_MCENTER      29
#define _SET_MESSAGE      30
#define _SET_PATH         31
#define _SET_PRINTER      32
#define _SET_PRINTFILE    33
#define _SET_SCOREBOARD   34
#define _SET_SCROLLBREAK  35
#define _SET_SOFTSEEK     36
#define _SET_TYPEAHEAD    37
#define _SET_UNIQUE       38
#define _SET_WRAP         39
