typedef union                  /* special structure used by lex and yacc to share info */
{
   char * string;       /* to hold a string returned by lex */
   int    iNumber;      /* to hold a number returned by lex */
   long   lNumber;      /* to hold a long number returned by lex */
   struct
   {
      double dNumber;   /* to hold a double number returned by lex */
      unsigned char bDec; /* to hold the number of decimal points in the value */
   } dNum;
   void * pVoid;        /* to hold any memory structure we may need */
} YYSTYPE;
#define	FUNCTION	258
#define	PROCEDURE	259
#define	IDENTIFIER	260
#define	RETURN	261
#define	NIL	262
#define	DOUBLE	263
#define	INASSIGN	264
#define	INTEGER	265
#define	INTLONG	266
#define	LOCAL	267
#define	STATIC	268
#define	IIF	269
#define	IF	270
#define	ELSE	271
#define	ELSEIF	272
#define	END	273
#define	ENDIF	274
#define	LITERAL	275
#define	TRUEVALUE	276
#define	FALSEVALUE	277
#define	EXTERN	278
#define	INIT	279
#define	EXIT	280
#define	AND	281
#define	OR	282
#define	NOT	283
#define	PUBLIC	284
#define	EQ	285
#define	NE1	286
#define	NE2	287
#define	INC	288
#define	DEC	289
#define	ALIAS	290
#define	DOCASE	291
#define	CASE	292
#define	OTHERWISE	293
#define	ENDCASE	294
#define	ENDDO	295
#define	MEMVAR	296
#define	WHILE	297
#define	LOOP	298
#define	FOR	299
#define	NEXT	300
#define	TO	301
#define	STEP	302
#define	LE	303
#define	GE	304
#define	FIELD	305
#define	IN	306
#define	PARAMETERS	307
#define	PLUSEQ	308
#define	MINUSEQ	309
#define	MULTEQ	310
#define	DIVEQ	311
#define	POWER	312
#define	EXPEQ	313
#define	MODEQ	314
#define	EXITLOOP	315
#define	PRIVATE	316
#define	BEGINSEQ	317
#define	BREAK	318
#define	RECOVER	319
#define	USING	320
#define	DO	321
#define	WITH	322
#define	SELF	323
#define	LINE	324
#define	AS_NUMERIC	325
#define	AS_CHARACTER	326
#define	AS_LOGICAL	327
#define	AS_DATE	328
#define	AS_ARRAY	329
#define	AS_BLOCK	330
#define	AS_OBJECT	331
#define	DECLARE_FUN	332
#define	POST	333
#define	UNARY	334
#define	PRE	335


extern YYSTYPE yylval;
