#include "pcode.h"
#include <init.h>

HARBOUR HB_ASORT( void );
static HARBOUR HB_QUICKSORT( void );
HARBOUR HB_VALTYPE( void );
HARBOUR HB_LEN( void );
HARBOUR HB_INT( void );
HARBOUR HB_EVAL( void );


HB_INIT_SYMBOLS_BEGIN( ASORT__InitSymbols )
{ "ASORT", FS_PUBLIC, HB_ASORT, 0 },
{ "VALTYPE", FS_PUBLIC, HB_VALTYPE, 0 },
{ "LEN", FS_PUBLIC, HB_LEN, 0 },
{ "QUICKSORT", FS_STATIC, HB_QUICKSORT, 0 },
{ "INT", FS_PUBLIC, HB_INT, 0 },
{ "EVAL", FS_PUBLIC, HB_EVAL, 0 }
HB_INIT_SYMBOLS_END( ASORT__InitSymbols );
#if ! defined(__GNUC__)
#pragma startup ASORT__InitSymbols
#endif


HARBOUR HB_ASORT( void )
{
  static BYTE pcode[] = { 
                HB_P_FRAME, 0, 4,		/* locals, params */
/* 00006 */  HB_P_LINE, 41, 0,		/* 41 */
                HB_P_PUSHSYM, 1, 0,      /* VALTYPE */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 2, 0,	/* NSTART */
                HB_P_FUNCTION, 1, 0,
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 'N',
                HB_P_EXACTLYEQUAL,
                HB_P_NOT,
                HB_P_JUMPFALSE, 16, 0,	/* 16 (abs: 00041) */
                HB_P_PUSHINT, 1, 0,     /* 1 */
                HB_P_POPLOCAL, 2, 0,	/* NSTART */
                HB_P_PUSHLOCAL, 2, 0,	/* NSTART */
                HB_P_POP,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00041) */
/* 00041 */  HB_P_LINE, 45, 0,		/* 45 */
                HB_P_PUSHSYM, 1, 0,      /* VALTYPE */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 3, 0,	/* NCOUNT */
                HB_P_FUNCTION, 1, 0,
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 'N',
                HB_P_EXACTLYEQUAL,
                HB_P_NOT,
                HB_P_JUMPFALSE, 31, 0,	/* 31 (abs: 00091) */
                HB_P_PUSHSYM, 2, 0,      /* LEN */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* AIN */
                HB_P_FUNCTION, 1, 0,
                HB_P_PUSHLOCAL, 2, 0,	/* NSTART */
                HB_P_MINUS,
                HB_P_PUSHINT, 1, 0,     /* 1 */
                HB_P_PLUS,
                HB_P_POPLOCAL, 3, 0,	/* NCOUNT */
                HB_P_PUSHLOCAL, 3, 0,	/* NCOUNT */
                HB_P_POP,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00091) */
/* 00091 */  HB_P_LINE, 49, 0,		/* 49 */
                HB_P_PUSHSYM, 1, 0,      /* VALTYPE */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 4, 0,	/* BBLOCK */
                HB_P_FUNCTION, 1, 0,
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 'B',
                HB_P_EXACTLYEQUAL,
                HB_P_NOT,
                HB_P_JUMPFALSE, 28, 0,	/* 28 (abs: 00138) */
                HB_P_PUSHBLOCK, 15, 0,	/* 15 */
                2, 0, 	/* number of local parameters (2) */
                0, 0, 	/* number of local variables (0) */
                HB_P_PUSHLOCAL, 1, 0,	/* codeblockvar1 */
                HB_P_PUSHLOCAL, 2, 0,	/* codeblockvar2 */
                HB_P_LESS,
                HB_P_ENDBLOCK,
                HB_P_POPLOCAL, 4, 0,	/* BBLOCK */
                HB_P_PUSHLOCAL, 4, 0,	/* BBLOCK */
                HB_P_POP,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00138) */
/* 00138 */  HB_P_LINE, 53, 0,		/* 53 */
                HB_P_PUSHSYM, 3, 0,      /* QUICKSORT */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* AIN */
                HB_P_PUSHLOCAL, 2, 0,	/* NSTART */
                HB_P_PUSHLOCAL, 3, 0,	/* NCOUNT */
                HB_P_PUSHLOCAL, 4, 0,	/* BBLOCK */
                HB_P_DO, 4, 0,
/* 00160 */  HB_P_LINE, 55, 0,		/* 55 */
                HB_P_PUSHLOCAL, 1, 0,	/* AIN */
                HB_P_RETVALUE,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00170) */
/* 00170 */  HB_P_ENDPROC };

   VirtualMachine( pcode, symbols );
}

static HARBOUR HB_QUICKSORT( void )
{
  static BYTE pcode[] = { 
                HB_P_FRAME, 5, 4,		/* locals, params */
/* 00006 */  HB_P_LINE, 68, 0,		/* 68 */
                HB_P_PUSHLOCAL, 2, 0,	/* NLEFT */
                HB_P_POPLOCAL, 5, 0,	/* NUP */
/* 00015 */  HB_P_LINE, 69, 0,		/* 69 */
                HB_P_PUSHLOCAL, 3, 0,	/* NRIGHT */
                HB_P_POPLOCAL, 6, 0,	/* NDOWN */
/* 00024 */  HB_P_LINE, 70, 0,		/* 70 */
                HB_P_PUSHLOCAL, 1, 0,	/* ASORT */
                HB_P_PUSHSYM, 4, 0,      /* INT */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 2, 0,	/* NLEFT */
                HB_P_PUSHLOCAL, 3, 0,	/* NRIGHT */
                HB_P_PLUS,
                HB_P_PUSHINT, 2, 0,     /* 2 */
                HB_P_DIVIDE,
                HB_P_FUNCTION, 1, 0,
                HB_P_ARRAYAT,
                HB_P_POPLOCAL, 7, 0,	/* XMIDDLE */
/* 00052 */  HB_P_LINE, 71, 0,		/* 71 */
/* 00055 */  HB_P_LINE, 72, 0,		/* 72 */
                HB_P_TRUE,
                HB_P_POPLOCAL, 9, 0,	/* LOK */
/* 00062 */  HB_P_LINE, 74, 0,		/* 74 */
                HB_P_PUSHLOCAL, 9, 0,	/* LOK */
                HB_P_JUMPFALSE, 204, 0,	/* 204 (abs: 00272) */
/* 00071 */  HB_P_LINE, 75, 0,		/* 75 */
                HB_P_PUSHSYM, 5, 0,      /* EVAL */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 4, 0,	/* BORDER */
                HB_P_PUSHLOCAL, 1, 0,	/* ASORT */
                HB_P_PUSHLOCAL, 5, 0,	/* NUP */
                HB_P_ARRAYAT,
                HB_P_PUSHLOCAL, 7, 0,	/* XMIDDLE */
                HB_P_FUNCTION, 3, 0,
                HB_P_JUMPFALSE, 18, 0,	/* 18 (abs: 00112) */
/* 00097 */  HB_P_LINE, 76, 0,		/* 76 */
                HB_P_PUSHLOCAL, 5, 0,	/* NUP */
                HB_P_DUPLICATE,
                HB_P_INC,
                HB_P_POPLOCAL, 5, 0,	/* NUP */
                HB_P_POP,
                HB_P_JUMP, 221, 255,	/* 65501 (abs: 65610) */
                HB_P_PUSHSYM, 5, 0,      /* EVAL */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 4, 0,	/* BORDER */
                HB_P_PUSHLOCAL, 7, 0,	/* XMIDDLE */
                HB_P_PUSHLOCAL, 1, 0,	/* ASORT */
                HB_P_PUSHLOCAL, 6, 0,	/* NDOWN */
                HB_P_ARRAYAT,
                HB_P_FUNCTION, 3, 0,
                HB_P_JUMPFALSE, 18, 0,	/* 18 (abs: 00150) */
/* 00135 */  HB_P_LINE, 80, 0,		/* 80 */
                HB_P_PUSHLOCAL, 6, 0,	/* NDOWN */
                HB_P_DUPLICATE,
                HB_P_DEC,
                HB_P_POPLOCAL, 6, 0,	/* NDOWN */
                HB_P_POP,
                HB_P_JUMP, 221, 255,	/* 65501 (abs: 65648) */
/* 00150 */  HB_P_LINE, 83, 0,		/* 83 */
                HB_P_PUSHLOCAL, 5, 0,	/* NUP */
                HB_P_PUSHLOCAL, 6, 0,	/* NDOWN */
                HB_P_LESSEQUAL,
                HB_P_JUMPFALSE, 89, 0,	/* 89 (abs: 00249) */
                HB_P_PUSHLOCAL, 5, 0,	/* NUP */
                HB_P_PUSHLOCAL, 6, 0,	/* NDOWN */
                HB_P_NOTEQUAL,
                HB_P_JUMPFALSE, 52, 0,	/* 52 (abs: 00222) */
                HB_P_PUSHLOCAL, 1, 0,	/* ASORT */
                HB_P_PUSHLOCAL, 5, 0,	/* NUP */
                HB_P_ARRAYAT,
                HB_P_POPLOCAL, 8, 0,	/* XTEMP */
                HB_P_PUSHLOCAL, 8, 0,	/* XTEMP */
                HB_P_POP,
/* 00187 */  HB_P_LINE, 86, 0,		/* 86 */
                HB_P_PUSHLOCAL, 1, 0,	/* ASORT */
                HB_P_PUSHLOCAL, 5, 0,	/* NUP */
                HB_P_PUSHLOCAL, 1, 0,	/* ASORT */
                HB_P_PUSHLOCAL, 6, 0,	/* NDOWN */
                HB_P_ARRAYAT,
                HB_P_ARRAYPUT,
                HB_P_POP,
/* 00205 */  HB_P_LINE, 87, 0,		/* 87 */
                HB_P_PUSHLOCAL, 1, 0,	/* ASORT */
                HB_P_PUSHLOCAL, 6, 0,	/* NDOWN */
                HB_P_PUSHLOCAL, 8, 0,	/* XTEMP */
                HB_P_ARRAYPUT,
                HB_P_POP,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00222) */
/* 00222 */  HB_P_LINE, 89, 0,		/* 89 */
                HB_P_PUSHLOCAL, 5, 0,	/* NUP */
                HB_P_DUPLICATE,
                HB_P_INC,
                HB_P_POPLOCAL, 5, 0,	/* NUP */
                HB_P_POP,
/* 00234 */  HB_P_LINE, 90, 0,		/* 90 */
                HB_P_PUSHLOCAL, 6, 0,	/* NDOWN */
                HB_P_DUPLICATE,
                HB_P_DEC,
                HB_P_POPLOCAL, 6, 0,	/* NDOWN */
                HB_P_POP,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00249) */
/* 00249 */  HB_P_LINE, 93, 0,		/* 93 */
                HB_P_PUSHLOCAL, 5, 0,	/* NUP */
                HB_P_PUSHLOCAL, 6, 0,	/* NDOWN */
                HB_P_LESSEQUAL,
                HB_P_POPLOCAL, 9, 0,	/* LOK */
                HB_P_PUSHLOCAL, 9, 0,	/* LOK */
                HB_P_POP,
/* 00266 */  HB_P_LINE, 94, 0,		/* 94 */
                HB_P_JUMP, 52, 255,	/* 65332 (abs: 65601) */
/* 00272 */  HB_P_LINE, 96, 0,		/* 96 */
                HB_P_PUSHLOCAL, 2, 0,	/* NLEFT */
                HB_P_PUSHLOCAL, 6, 0,	/* NDOWN */
                HB_P_LESS,
                HB_P_JUMPFALSE, 25, 0,	/* 25 (abs: 00307) */
                HB_P_PUSHSYM, 3, 0,      /* QUICKSORT */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* ASORT */
                HB_P_PUSHLOCAL, 2, 0,	/* NLEFT */
                HB_P_PUSHLOCAL, 6, 0,	/* NDOWN */
                HB_P_PUSHLOCAL, 4, 0,	/* BORDER */
                HB_P_DO, 4, 0,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00307) */
/* 00307 */  HB_P_LINE, 100, 0,		/* 100 */
                HB_P_PUSHLOCAL, 5, 0,	/* NUP */
                HB_P_PUSHLOCAL, 3, 0,	/* NRIGHT */
                HB_P_LESS,
                HB_P_JUMPFALSE, 25, 0,	/* 25 (abs: 00342) */
                HB_P_PUSHSYM, 3, 0,      /* QUICKSORT */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* ASORT */
                HB_P_PUSHLOCAL, 5, 0,	/* NUP */
                HB_P_PUSHLOCAL, 3, 0,	/* NRIGHT */
                HB_P_PUSHLOCAL, 4, 0,	/* BORDER */
                HB_P_DO, 4, 0,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00342) */
/* 00342 */  HB_P_LINE, 104, 0,		/* 104 */
                HB_P_PUSHNIL,
                HB_P_RETVALUE,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00350) */
/* 00350 */  HB_P_ENDPROC };

   VirtualMachine( pcode, symbols );
}

