#include "pcode.h"
#include <init.h>

static HARBOUR HB_CLIPINIT( void );
static HARBOUR HB_DEFERROR( void );
HARBOUR HB_ERRORSYS( void );
static HARBOUR HB_ERRORMESSAGE( void );
HARBOUR HB_ERRORSYS( void );
HARBOUR HB_EMPTY( void );
HARBOUR HB_LTRIM( void );
HARBOUR HB_STR( void );
HARBOUR HB_QOUT( void );
HARBOUR HB_PROCNAME( void );
HARBOUR HB_ALLTRIM( void );
HARBOUR HB_PROCLINE( void );
HARBOUR HB_ERRORLEVEL( void );
HARBOUR HB___QUIT( void );
HARBOUR HB_ERRORBLOCK( void );
HARBOUR HB_VALTYPE( void );


HB_INIT_SYMBOLS_BEGIN( ERRORSYS__InitSymbols )
{ "CLIPINIT", FS_INIT, HB_CLIPINIT, 0 },
{ "ERRORSYS", FS_PUBLIC, HB_ERRORSYS, 0 },
{ "DEFERROR", FS_STATIC, HB_DEFERROR, 0 },
{ "ERRORMESSAGE", FS_STATIC, HB_ERRORMESSAGE, 0 },
{ "EMPTY", FS_PUBLIC, HB_EMPTY, 0 },
{ "OSCODE", FS_PUBLIC, 0, 0 },
{ "LTRIM", FS_PUBLIC, HB_LTRIM, 0 },
{ "STR", FS_PUBLIC, HB_STR, 0 },
{ "QOUT", FS_PUBLIC, HB_QOUT, 0 },
{ "PROCNAME", FS_PUBLIC, HB_PROCNAME, 0 },
{ "ALLTRIM", FS_PUBLIC, HB_ALLTRIM, 0 },
{ "PROCLINE", FS_PUBLIC, HB_PROCLINE, 0 },
{ "ERRORLEVEL", FS_PUBLIC, HB_ERRORLEVEL, 0 },
{ "__QUIT", FS_PUBLIC, HB___QUIT, 0 },
{ "ERRORBLOCK", FS_PUBLIC, HB_ERRORBLOCK, 0 },
{ "SEVERITY", FS_PUBLIC, 0, 0 },
{ "VALTYPE", FS_PUBLIC, HB_VALTYPE, 0 },
{ "SUBSYSTEM", FS_PUBLIC, 0, 0 },
{ "SUBCODE", FS_PUBLIC, 0, 0 },
{ "DESCRIPTION", FS_PUBLIC, 0, 0 },
{ "FILENAME", FS_PUBLIC, 0, 0 },
{ "OPERATION", FS_PUBLIC, 0, 0 }
HB_INIT_SYMBOLS_END( ERRORSYS__InitSymbols );
#if ! defined(__GNUC__)
#pragma startup ERRORSYS__InitSymbols
#endif


static HARBOUR HB_CLIPINIT( void )
{
  static BYTE pcode[] = { 
/* 00006 */  HB_P_LINE, 38, 0,		/* 38 */
                HB_P_PUSHSYM, 1, 0,      /* ERRORSYS */
                HB_P_PUSHNIL,
                HB_P_DO, 0, 0,
/* 00016 */  HB_P_LINE, 40, 0,		/* 40 */
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00022) */
/* 00022 */  HB_P_ENDPROC };

   VirtualMachine( pcode, symbols );
}

static HARBOUR HB_DEFERROR( void )
{
  static BYTE pcode[] = { 
                HB_P_FRAME, 3, 1,		/* locals, params */
/* 00006 */  HB_P_LINE, 45, 0,		/* 45 */
/* 00009 */  HB_P_LINE, 47, 0,		/* 47 */
                HB_P_PUSHSTR, 0, 0,     /* 0 */

                HB_P_POPLOCAL, 3, 0,	/* CINFO */
/* 00018 */  HB_P_LINE, 48, 0,		/* 48 */
                HB_P_PUSHINT, 2, 0,     /* 2 */
                HB_P_POPLOCAL, 4, 0,	/* N */
/* 00027 */  HB_P_LINE, 50, 0,		/* 50 */
                HB_P_PUSHSYM, 3, 0,      /* ERRORMESSAGE */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_FUNCTION, 1, 0,
                HB_P_POPLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_POP,
/* 00047 */  HB_P_LINE, 51, 0,		/* 51 */
                HB_P_PUSHSYM, 4, 0,      /* EMPTY */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 5, 0,      /* OSCODE */
                HB_P_FUNCTION, 0, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_NOT,
                HB_P_JUMPFALSE, 61, 0,	/* 61 (abs: 00128) */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHSTR, 12, 0,     /* 12 */
 ' ', '(', 'D', 'O', 'S', ' ', 'E', 'r', 'r', 'o', 'r', ' ',
                HB_P_PUSHSYM, 6, 0,      /* LTRIM */
                HB_P_PUSHNIL,
                HB_P_PUSHSYM, 7, 0,      /* STR */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 5, 0,      /* OSCODE */
                HB_P_FUNCTION, 0, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_PLUS,
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 ')',
                HB_P_PLUS,
                HB_P_PLUS,
                HB_P_POPLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_POP,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00128) */
/* 00128 */  HB_P_LINE, 55, 0,		/* 55 */
                HB_P_PUSHSYM, 8, 0,      /* QOUT */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_DO, 1, 0,
/* 00141 */  HB_P_LINE, 57, 0,		/* 57 */
                HB_P_PUSHSYM, 4, 0,      /* EMPTY */
                HB_P_PUSHNIL,
                HB_P_PUSHSYM, 9, 0,      /* PROCNAME */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 4, 0,	/* N */
                HB_P_FUNCTION, 1, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_NOT,
                HB_P_JUMPFALSE, 82, 0,	/* 82 (abs: 00244) */
/* 00165 */  HB_P_LINE, 59, 0,		/* 59 */
                HB_P_PUSHSYM, 8, 0,      /* QOUT */
                HB_P_PUSHNIL,
                HB_P_PUSHSTR, 12, 0,     /* 12 */
 'C', 'a', 'l', 'l', 'e', 'd', ' ', 'f', 'r', 'o', 'm', ' ',
                HB_P_PUSHSYM, 9, 0,      /* PROCNAME */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 4, 0,	/* N */
                HB_P_FUNCTION, 1, 0,
                HB_P_PLUS,
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 '(',
                HB_P_PLUS,
                HB_P_PUSHSYM, 10, 0,      /* ALLTRIM */
                HB_P_PUSHNIL,
                HB_P_PUSHSYM, 7, 0,      /* STR */
                HB_P_PUSHNIL,
                HB_P_PUSHSYM, 11, 0,      /* PROCLINE */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 4, 0,	/* N */
                HB_P_DUPLICATE,
                HB_P_INC,
                HB_P_POPLOCAL, 4, 0,	/* N */
                HB_P_FUNCTION, 1, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_PLUS,
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 ')',
                HB_P_PLUS,
                HB_P_DO, 1, 0,
                HB_P_JUMP, 159, 255,	/* 65439 (abs: 65680) */
/* 00244 */  HB_P_LINE, 64, 0,		/* 64 */
                HB_P_PUSHSYM, 12, 0,      /* ERRORLEVEL */
                HB_P_PUSHNIL,
                HB_P_PUSHINT, 1, 0,     /* 1 */
                HB_P_DO, 1, 0,
/* 00257 */  HB_P_LINE, 65, 0,		/* 65 */
                HB_P_PUSHSYM, 13, 0,      /* __QUIT */
                HB_P_PUSHNIL,
                HB_P_DO, 0, 0,
/* 00267 */  HB_P_LINE, 67, 0,		/* 67 */
                HB_P_FALSE,
                HB_P_RETVALUE,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00275) */
/* 00275 */  HB_P_ENDPROC };

   VirtualMachine( pcode, symbols );
}

HARBOUR HB_ERRORSYS( void )
{
  static BYTE pcode[] = { 
/* 00006 */  HB_P_LINE, 73, 0,		/* 73 */
                HB_P_PUSHSYM, 14, 0,      /* ERRORBLOCK */
                HB_P_PUSHNIL,
                HB_P_PUSHBLOCK, 18, 0,	/* 18 */
                1, 0, 	/* number of local parameters (1) */
                0, 0, 	/* number of local variables (0) */
                HB_P_PUSHSYM, 2, 0,      /* DEFERROR */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* codeblockvar1 */
                HB_P_FUNCTION, 1, 0,
                HB_P_ENDBLOCK,
                HB_P_DO, 1, 0,
/* 00034 */  HB_P_LINE, 75, 0,		/* 75 */
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00040) */
/* 00040 */  HB_P_ENDPROC };

   VirtualMachine( pcode, symbols );
}

static HARBOUR HB_ERRORMESSAGE( void )
{
  static BYTE pcode[] = { 
                HB_P_FRAME, 1, 1,		/* locals, params */
/* 00006 */  HB_P_LINE, 80, 0,		/* 80 */
/* 00009 */  HB_P_LINE, 83, 0,		/* 83 */
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 15, 0,      /* SEVERITY */
                HB_P_FUNCTION, 0, 0,
                HB_P_PUSHINT, 1, 0,     /* 1 */
                HB_P_GREATER,
                HB_P_JUMPFALSE, 14, 0,	/* 14 (abs: 00039) */
                HB_P_PUSHSTR, 5, 0,     /* 5 */
 'E', 'r', 'r', 'o', 'r',
                HB_P_JUMP, 13, 0,	/* 13 (abs: 00049) */
                HB_P_PUSHSTR, 7, 0,     /* 7 */
 'W', 'a', 'r', 'n', 'i', 'n', 'g',
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 ' ',
                HB_P_PLUS,
                HB_P_POPLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_POP,
/* 00061 */  HB_P_LINE, 86, 0,		/* 86 */
                HB_P_PUSHSYM, 16, 0,      /* VALTYPE */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 17, 0,      /* SUBSYSTEM */
                HB_P_FUNCTION, 0, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 'C',
                HB_P_EXACTLYEQUAL,
                HB_P_JUMPFALSE, 26, 0,	/* 26 (abs: 00111) */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 17, 0,      /* SUBSYSTEM */
                HB_P_FUNCTION, 0, 0,
                HB_P_PLUS,
                HB_P_POPLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_POP,
                HB_P_JUMP, 20, 0,	/* 20 (abs: 00128) */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHSTR, 3, 0,     /* 3 */
 '?', '?', '?',
                HB_P_PLUS,
                HB_P_POPLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_POP,
/* 00128 */  HB_P_LINE, 93, 0,		/* 93 */
                HB_P_PUSHSYM, 16, 0,      /* VALTYPE */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 18, 0,      /* SUBCODE */
                HB_P_FUNCTION, 0, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 'N',
                HB_P_EXACTLYEQUAL,
                HB_P_JUMPFALSE, 45, 0,	/* 45 (abs: 00197) */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 '/',
                HB_P_PUSHSYM, 6, 0,      /* LTRIM */
                HB_P_PUSHNIL,
                HB_P_PUSHSYM, 7, 0,      /* STR */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 18, 0,      /* SUBCODE */
                HB_P_FUNCTION, 0, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_PLUS,
                HB_P_PLUS,
                HB_P_POPLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_POP,
                HB_P_JUMP, 21, 0,	/* 21 (abs: 00215) */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHSTR, 4, 0,     /* 4 */
 '/', '?', '?', '?',
                HB_P_PLUS,
                HB_P_POPLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_POP,
/* 00215 */  HB_P_LINE, 100, 0,		/* 100 */
                HB_P_PUSHSYM, 16, 0,      /* VALTYPE */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 19, 0,      /* DESCRIPTION */
                HB_P_FUNCTION, 0, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_PUSHSTR, 1, 0,     /* 1 */
 'C',
                HB_P_EXACTLYEQUAL,
                HB_P_JUMPFALSE, 32, 0,	/* 32 (abs: 00271) */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHSTR, 2, 0,     /* 2 */
 ' ', ' ',
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 19, 0,      /* DESCRIPTION */
                HB_P_FUNCTION, 0, 0,
                HB_P_PLUS,
                HB_P_PLUS,
                HB_P_POPLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_POP,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00271) */
/* 00271 */  HB_P_LINE, 105, 0,		/* 105 */
                HB_P_PUSHSYM, 4, 0,      /* EMPTY */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 20, 0,      /* FILENAME */
                HB_P_FUNCTION, 0, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_NOT,
                HB_P_JUMPFALSE, 35, 0,	/* 35 (abs: 00326) */
/* 00294 */  HB_P_LINE, 107, 0,		/* 107 */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHSTR, 2, 0,     /* 2 */
 ':', ' ',
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 20, 0,      /* FILENAME */
                HB_P_FUNCTION, 0, 0,
                HB_P_PLUS,
                HB_P_PLUS,
                HB_P_POPLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_POP,
                HB_P_JUMP, 61, 0,	/* 61 (abs: 00384) */
/* 00326 */  HB_P_LINE, 108, 0,		/* 108 */
                HB_P_PUSHSYM, 4, 0,      /* EMPTY */
                HB_P_PUSHNIL,
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 21, 0,      /* OPERATION */
                HB_P_FUNCTION, 0, 0,
                HB_P_FUNCTION, 1, 0,
                HB_P_NOT,
                HB_P_JUMPFALSE, 35, 0,	/* 35 (abs: 00381) */
/* 00349 */  HB_P_LINE, 109, 0,		/* 109 */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHSTR, 2, 0,     /* 2 */
 ':', ' ',
                HB_P_PUSHLOCAL, 1, 0,	/* OERROR */
                HB_P_MESSAGE, 21, 0,      /* OPERATION */
                HB_P_FUNCTION, 0, 0,
                HB_P_PLUS,
                HB_P_PLUS,
                HB_P_POPLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_POP,
                HB_P_JUMP, 6, 0,	/* 6 (abs: 00384) */
/* 00381 */  HB_P_LINE, 110, 0,		/* 110 */
/* 00384 */  HB_P_LINE, 112, 0,		/* 112 */
                HB_P_PUSHLOCAL, 2, 0,	/* CMESSAGE */
                HB_P_RETVALUE,
                HB_P_JUMP, 3, 0,	/* 3 (abs: 00394) */
/* 00394 */  HB_P_ENDPROC };

   VirtualMachine( pcode, symbols );
}

